/*-----------------------------------------------------------------------------}
{ TJBFrom v1.00                                                                }
{------------------------------------------------------------------------------}
{ A new form adding a lot of new functionallity to you forms, just by making   }
{ your form inherits form TJBFrom in stead of TForm. Se Demo for details       |
{                                                                              }
{ Copyright 2002, Jens Borrisholt.  All Rights Reserved.                       }
{                                                                              }
{ Copyright:                                                                   }
{ All Delphi Free Stuff (hereafter "DFS") source code is copyrighted by        }
{ Jens Borrosholt (hereafter "author"), and shall remain the exclusive         }
{ property of the author.                                                      }
{                                                                              }
{ Distribution Rights:                                                         }
{ You are granted a non-exlusive, royalty-free right to produce and distribute }
{ compiled binary files (executables, DLLs, etc.) that are built with any of   }
{ the DFS source code unless specifically stated otherwise.                    }
{ You are further granted permission to redistribute any of the DFS source     }
{ code in source code form, provided that the original archive as found on the }
{ DFS web site (http://www.delphifreestuff.com) is distributed unmodified.     }
{                                                                              }
{ Restrictions:                                                                }
{ Without the express written consent of the author, you may not:              }
{   * Distribute modified versions of any DFS source code by itself. You must  }
{     include the original archive as you found it at the DFS site.            }
{   * Sell or lease any portion of DFS source code. You are, of course, free   }
{     to sell any of your own original code that works with, enhances, etc.    }
{     DFS source code.                                                         }
{   * Distribute DFS source code for profit.                                   }
{                                                                              }
{ Warranty:                                                                    }
{ There is absolutely no warranty of any kind whatsoever with any of the DFS   }
{ source code (hereafter "software"). The software is provided to you "AS-IS", }
{ and all risks and losses associated with it's use are assumed by you. In no  }
{ event shall the author of the softare, Jens Borrisholt, be held              }
{ accountable for any damages or losses that may occur from use or misuse of   }
{ the software.                                                                }
{                                                                              }
{ Support:                                                                     }
{ Support is provided via E-Mail, Jens@Borrisholt.com or by                    }
{ www.eksperten.dk Support Forum, which is a web-based message system.         }
{ All DFS source code is provided free of charge. As such, I can not guarantee }
{ any support whatsoever. While I do try to answer all questions that I        }
{ receive and address all problems that are reported to me, you must           }
{ understand that I simply can not guarantee that this will always be so.      }
{                                                                              }
{ Clarifications:                                                              }
{ If you need any further information, please feel free to contact me directly.}
{------------------------------------------------------------------------------}
{ Date last modified:  August  04, 2002                                        }
{------------------------------------------------------------------------------}
{------------------------------------------------------------------------------}
{ Revision History:                                                            }
{                                                                              }
{ 04-08-2002  :                                                                }
{      V 1.00  Project created.                                                }
{------------------------------------------------------------------------------}

{:
  This is not a component it is a new form.

  This new form adding a lot of new functionallity to you forms, just by making
  your form inherits form TJBFrom instead of TForm. You can do that to "new"
  forms, or you can even use it in a project you are working on.

  TJBFrom is easy tou use, alle there realy are in to it a two steps :

  1)
   Delphi :
     Add UnitJBForm to you uses clausule, in the top of the unit contaning
     your form.
   C++ Builder :
     #include "UnitJBForm.h" in thw headder file contaning the interface for
     your form.
  2)
   Make your form inherits TJBForm instead of TForm.

   Delphi :
     Go to the definition of your form change
     TForm1 = class(TForm) to TForm1 = class(TJBForm)
   C++ Builder :
     A)
     Go to the headder file contaning the definition of your form change
     class TForm1 : public TForm to class TForm1 : public TJBForm

     B)
     Go to the refering cpp file (by pressing [ctrl] +[F6] anf find the constructor
     for you from. change

     __fastcall TForm1::TForm1(TComponent* Owner)  : TForm(Owner)

     to
     __fastcall TForm1::TForm1(TComponent* Owner)  : TJBForm(Owner)


   if you like the product, or make changer, and/or bug fixes then please tell me
   about it by contacting me direct : Jens@Borrisholt.com
:*/


#ifndef UnitJBFormHPP
#define UnitJBFormHPP

#include <Controls.hpp>
#include <Messages.hpp>
#include <Classes.hpp>
#include <Forms.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>



#include "SubCls.h"

namespace Unitjbform
{

typedef Shortint TPercent;
class TMyControlSubclass;
class TJBForm;
class TJBForm : public Forms::TForm
{
  typedef Forms::TForm inherited;
  friend TMyControlSubclass;
  private:
     bool FShowCaption;
     bool FSnapToEdge;
     TPercent FMargin;
     TMyControlSubclass* FSubclass;
     int FTransparency;
     bool FUseTransparency;
     bool FMoveFormByControls;
     void __fastcall SetMargin(const TPercent Value);
     void __fastcall SetSnapToEdge(const bool Value);
     void __fastcall SetShowCaption(const bool Value);
     void __fastcall SetTransparency(const int Value);
     void __fastcall SetUseTransparency(const bool Value);
     void __fastcall SetMoveFormByControls(const bool Value);
  public:
    __fastcall virtual TJBForm(Classes::TComponent* AOwner);
    __fastcall virtual ~TJBForm(void);
  __published:
    __property bool ShowCaption = {read=FShowCaption, write=SetShowCaption, nodefault};
    __property bool SnapToEdge = {read=FSnapToEdge, write=SetSnapToEdge, nodefault};
    __property TPercent Margin = {read=FMargin, write=SetMargin, default=2};
    __property int Transparency = {read=FTransparency, write=SetTransparency, nodefault};
    __property bool UseTransparency = {read=FUseTransparency, write=SetUseTransparency, nodefault};
    __property bool MoveFormByControls = {read=FMoveFormByControls, write=SetMoveFormByControls, nodefault};
  public:
    /* TCustomForm.CreateNew */ inline __fastcall virtual TJBForm(Classes::TComponent* AOwner, int Dummy ) : Forms::TForm(AOwner, Dummy) { }
  public:
    /* TWinControl.CreateParented */ inline __fastcall TJBForm(HWND ParentWindow) : Forms::TForm(ParentWindow) { }
};


class TMyControlSubclass : public Subcls::TControlSubclass
{
  typedef Subcls::TControlSubclass inherited;

  private:
    Windows::TPoint OldP;
    Windows::TPoint OldQ;
    TJBForm* JBForm;
    bool LBDown;
    bool Timer1;
    bool Timer2;
    TJBForm* __fastcall GetParentForm(Controls::TControl* Control);
    unsigned __fastcall SetTimer(HWND hWnd, unsigned nIDEvent, unsigned uElapse, TIMERPROC lpTimerFunc);
    BOOL __fastcall KillTimer(HWND hWnd, unsigned uIDEvent);
  protected:
    virtual void __fastcall BeforeWndProc(Controls::TControl* Control, Messages::TMessage &Message);
    virtual void __fastcall AfterWndProc(Controls::TControl* Control, Messages::TMessage &Message);
    void __fastcall doMouseDown(void);
    void __fastcall doMouseMove(void);
    void __fastcall doMouseUp(void);
    void __fastcall doNcMouseMove(void);
    void __fastcall doBlendUp(void);
    void __fastcall doBlendDown(void);
  public:
    __fastcall TMyControlSubclass(void);
  public:
     inline __fastcall virtual ~TMyControlSubclass(void) { }
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Unitjbform */

#if !defined(NO_IMPLICIT_NAMESPACE_USE)
  using namespace Unitjbform;
#endif

#endif	// UnitJBForm
