unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, UnitJBForm, ExtCtrls, StdCtrls, Spin;

type
  TForm1 = class(TJBForm)
    Panel1: TPanel;
    Panel2: TPanel;

    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;

    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;

    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    procedure CheckBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  ShowCaption := CheckBox1.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Panel2.Tag := 1;

  (*
    By setting the tag property to a value diffrent fron 0 (Zero)
    You prevent TJBForm to subclass the control. You can set this value
    either by design time or by runtime.
  *)
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  SnapToEdge := CheckBox2.Checked;
  SpinEdit1.Enabled := CheckBox2.Checked;
  Label1.Enabled := CheckBox2.Checked;
  Label2.Enabled := CheckBox2.Checked;
end;

procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  Margin := SpinEdit1.Value

  (*
    HINT :

    If you do not want the form to snap to the edge of your screen, but still
    want to prevent the form to be hidden outsite the visible area of your screen,
    you should enable SnapToEdge AND setting margin to 0 (Zero)
  *)
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  MoveFormByControls := CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  UseTransparency := CheckBox4.Checked;
end;

procedure TForm1.SpinEdit2Change(Sender: TObject);
begin
  Transparency := SpinEdit2.Value;
end;

end.
